<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BelgianBusinessDatedItem StructType
 * @subpackage Structs
 */
class BelgianBusinessDatedItem extends AbstractStructBase
{
    /**
     * The code
     * @var string
     */
    public $code;
    /**
     * The label
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $label;
    /**
     * The start_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDate
     */
    public $start_date;
    /**
     * The end_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\BelgianBusinessDate
     */
    public $end_date;
    /**
     * Constructor method for BelgianBusinessDatedItem
     * @uses BelgianBusinessDatedItem::setCode()
     * @uses BelgianBusinessDatedItem::setLabel()
     * @uses BelgianBusinessDatedItem::setStart_date()
     * @uses BelgianBusinessDatedItem::setEnd_date()
     * @param string $code
     * @param string $label
     * @param \StructType\BelgianBusinessDate $start_date
     * @param \StructType\BelgianBusinessDate $end_date
     */
    public function __construct($code = null, $label = null, \StructType\BelgianBusinessDate $start_date = null, \StructType\BelgianBusinessDate $end_date = null)
    {
        $this
            ->setCode($code)
            ->setLabel($label)
            ->setStart_date($start_date)
            ->setEnd_date($end_date);
    }
    /**
     * Get code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->code;
    }
    /**
     * Set code value
     * @param string $code
     * @return \StructType\BelgianBusinessDatedItem
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->code = $code;
        return $this;
    }
    /**
     * Get label value
     * @return string|null
     */
    public function getLabel()
    {
        return $this->label;
    }
    /**
     * Set label value
     * @param string $label
     * @return \StructType\BelgianBusinessDatedItem
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        $this->label = $label;
        return $this;
    }
    /**
     * Get start_date value
     * @return \StructType\BelgianBusinessDate|null
     */
    public function getStart_date()
    {
        return $this->start_date;
    }
    /**
     * Set start_date value
     * @param \StructType\BelgianBusinessDate $start_date
     * @return \StructType\BelgianBusinessDatedItem
     */
    public function setStart_date(\StructType\BelgianBusinessDate $start_date = null)
    {
        $this->start_date = $start_date;
        return $this;
    }
    /**
     * Get end_date value
     * @return \StructType\BelgianBusinessDate|null
     */
    public function getEnd_date()
    {
        return $this->end_date;
    }
    /**
     * Set end_date value
     * @param \StructType\BelgianBusinessDate $end_date
     * @return \StructType\BelgianBusinessDatedItem
     */
    public function setEnd_date(\StructType\BelgianBusinessDate $end_date = null)
    {
        $this->end_date = $end_date;
        return $this;
    }
}
