<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for BusinessDossierV2PagedResult StructType
 * @subpackage Structs
 */
class BusinessDossierV2PagedResult extends AbstractStructBase
{
    /**
     * The paging
     * @var \StructType\ResultInfo
     */
    public $paging;
    /**
     * The results
     * @var \ArrayType\BusinessDossierV2Array
     */
    public $results;
    /**
     * Constructor method for BusinessDossierV2PagedResult
     * @uses BusinessDossierV2PagedResult::setPaging()
     * @uses BusinessDossierV2PagedResult::setResults()
     * @param \StructType\ResultInfo $paging
     * @param \ArrayType\BusinessDossierV2Array $results
     */
    public function __construct(\StructType\ResultInfo $paging = null, \ArrayType\BusinessDossierV2Array $results = null)
    {
        $this
            ->setPaging($paging)
            ->setResults($results);
    }
    /**
     * Get paging value
     * @return \StructType\ResultInfo|null
     */
    public function getPaging()
    {
        return $this->paging;
    }
    /**
     * Set paging value
     * @param \StructType\ResultInfo $paging
     * @return \StructType\BusinessDossierV2PagedResult
     */
    public function setPaging(\StructType\ResultInfo $paging = null)
    {
        $this->paging = $paging;
        return $this;
    }
    /**
     * Get results value
     * @return \ArrayType\BusinessDossierV2Array|null
     */
    public function getResults()
    {
        return $this->results;
    }
    /**
     * Set results value
     * @param \ArrayType\BusinessDossierV2Array $results
     * @return \StructType\BusinessDossierV2PagedResult
     */
    public function setResults(\ArrayType\BusinessDossierV2Array $results = null)
    {
        $this->results = $results;
        return $this;
    }
}
