<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarVWEOptionPackage StructType
 * @subpackage Structs
 */
class CarVWEOptionPackage extends AbstractStructBase
{
    /**
     * The package_id
     * @var int
     */
    public $package_id;
    /**
     * The price
     * @var int
     */
    public $price;
    /**
     * The description
     * @var string
     */
    public $description;
    /**
     * The options
     * @var \ArrayType\CarVWEOptionArray
     */
    public $options;
    /**
     * Constructor method for CarVWEOptionPackage
     * @uses CarVWEOptionPackage::setPackage_id()
     * @uses CarVWEOptionPackage::setPrice()
     * @uses CarVWEOptionPackage::setDescription()
     * @uses CarVWEOptionPackage::setOptions()
     * @param int $package_id
     * @param int $price
     * @param string $description
     * @param \ArrayType\CarVWEOptionArray $options
     */
    public function __construct($package_id = null, $price = null, $description = null, \ArrayType\CarVWEOptionArray $options = null)
    {
        $this
            ->setPackage_id($package_id)
            ->setPrice($price)
            ->setDescription($description)
            ->setOptions($options);
    }
    /**
     * Get package_id value
     * @return int|null
     */
    public function getPackage_id()
    {
        return $this->package_id;
    }
    /**
     * Set package_id value
     * @param int $package_id
     * @return \StructType\CarVWEOptionPackage
     */
    public function setPackage_id($package_id = null)
    {
        // validation for constraint: int
        if (!is_null($package_id) && !(is_int($package_id) || ctype_digit($package_id))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($package_id, true), gettype($package_id)), __LINE__);
        }
        $this->package_id = $package_id;
        return $this;
    }
    /**
     * Get price value
     * @return int|null
     */
    public function getPrice()
    {
        return $this->price;
    }
    /**
     * Set price value
     * @param int $price
     * @return \StructType\CarVWEOptionPackage
     */
    public function setPrice($price = null)
    {
        // validation for constraint: int
        if (!is_null($price) && !(is_int($price) || ctype_digit($price))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($price, true), gettype($price)), __LINE__);
        }
        $this->price = $price;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \StructType\CarVWEOptionPackage
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->description = $description;
        return $this;
    }
    /**
     * Get options value
     * @return \ArrayType\CarVWEOptionArray|null
     */
    public function getOptions()
    {
        return $this->options;
    }
    /**
     * Set options value
     * @param \ArrayType\CarVWEOptionArray $options
     * @return \StructType\CarVWEOptionPackage
     */
    public function setOptions(\ArrayType\CarVWEOptionArray $options = null)
    {
        $this->options = $options;
        return $this;
    }
}
