<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CarVWEPhoto StructType
 * @subpackage Structs
 */
class CarVWEPhoto extends AbstractStructBase
{
    /**
     * The image
     * @var string
     */
    public $image;
    /**
     * The side
     * @var string
     */
    public $side;
    /**
     * The size
     * @var string
     */
    public $size;
    /**
     * Constructor method for CarVWEPhoto
     * @uses CarVWEPhoto::setImage()
     * @uses CarVWEPhoto::setSide()
     * @uses CarVWEPhoto::setSize()
     * @param string $image
     * @param string $side
     * @param string $size
     */
    public function __construct($image = null, $side = null, $size = null)
    {
        $this
            ->setImage($image)
            ->setSide($side)
            ->setSize($size);
    }
    /**
     * Get image value
     * @return string|null
     */
    public function getImage()
    {
        return $this->image;
    }
    /**
     * Set image value
     * @param string $image
     * @return \StructType\CarVWEPhoto
     */
    public function setImage($image = null)
    {
        // validation for constraint: string
        if (!is_null($image) && !is_string($image)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($image, true), gettype($image)), __LINE__);
        }
        $this->image = $image;
        return $this;
    }
    /**
     * Get side value
     * @return string|null
     */
    public function getSide()
    {
        return $this->side;
    }
    /**
     * Set side value
     * @param string $side
     * @return \StructType\CarVWEPhoto
     */
    public function setSide($side = null)
    {
        // validation for constraint: string
        if (!is_null($side) && !is_string($side)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($side, true), gettype($side)), __LINE__);
        }
        $this->side = $side;
        return $this;
    }
    /**
     * Get size value
     * @return string|null
     */
    public function getSize()
    {
        return $this->size;
    }
    /**
     * Set size value
     * @param string $size
     * @return \StructType\CarVWEPhoto
     */
    public function setSize($size = null)
    {
        // validation for constraint: string
        if (!is_null($size) && !is_string($size)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($size, true), gettype($size)), __LINE__);
        }
        $this->size = $size;
        return $this;
    }
}
