<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditsafePreviousDirector StructType
 * @subpackage Structs
 */
class CreditsafePreviousDirector extends AbstractStructBase
{
    /**
     * The director
     * @var \StructType\CreditsafeDirector
     */
    public $director;
    /**
     * The resignation_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $resignation_date;
    /**
     * Constructor method for CreditsafePreviousDirector
     * @uses CreditsafePreviousDirector::setDirector()
     * @uses CreditsafePreviousDirector::setResignation_date()
     * @param \StructType\CreditsafeDirector $director
     * @param string $resignation_date
     */
    public function __construct(\StructType\CreditsafeDirector $director = null, $resignation_date = null)
    {
        $this
            ->setDirector($director)
            ->setResignation_date($resignation_date);
    }
    /**
     * Get director value
     * @return \StructType\CreditsafeDirector|null
     */
    public function getDirector()
    {
        return $this->director;
    }
    /**
     * Set director value
     * @param \StructType\CreditsafeDirector $director
     * @return \StructType\CreditsafePreviousDirector
     */
    public function setDirector(\StructType\CreditsafeDirector $director = null)
    {
        $this->director = $director;
        return $this;
    }
    /**
     * Get resignation_date value
     * @return string|null
     */
    public function getResignation_date()
    {
        return $this->resignation_date;
    }
    /**
     * Set resignation_date value
     * @param string $resignation_date
     * @return \StructType\CreditsafePreviousDirector
     */
    public function setResignation_date($resignation_date = null)
    {
        // validation for constraint: string
        if (!is_null($resignation_date) && !is_string($resignation_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($resignation_date, true), gettype($resignation_date)), __LINE__);
        }
        $this->resignation_date = $resignation_date;
        return $this;
    }
}
