<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessLeiBusinessEntity StructType
 * @subpackage Structs
 */
class DutchBusinessLeiBusinessEntity extends AbstractStructBase
{
    /**
     * The company_name
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $company_name;
    /**
     * The legal_status
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $legal_status;
    /**
     * The legal_form
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiLegalForm
     */
    public $legal_form;
    /**
     * The headquarters_address
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiAddress
     */
    public $headquarters_address;
    /**
     * The legal_address
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiAddress
     */
    public $legal_address;
    /**
     * The registration_authority
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\DutchBusinessLeiRegistrationAuthority
     */
    public $registration_authority;
    /**
     * The expiration_date
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $expiration_date;
    /**
     * The expiration_reason
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $expiration_reason;
    /**
     * The successor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\DutchBusinessLeiSuccessor
     */
    public $successor;
    /**
     * Constructor method for DutchBusinessLeiBusinessEntity
     * @uses DutchBusinessLeiBusinessEntity::setCompany_name()
     * @uses DutchBusinessLeiBusinessEntity::setLegal_status()
     * @uses DutchBusinessLeiBusinessEntity::setLegal_form()
     * @uses DutchBusinessLeiBusinessEntity::setHeadquarters_address()
     * @uses DutchBusinessLeiBusinessEntity::setLegal_address()
     * @uses DutchBusinessLeiBusinessEntity::setRegistration_authority()
     * @uses DutchBusinessLeiBusinessEntity::setExpiration_date()
     * @uses DutchBusinessLeiBusinessEntity::setExpiration_reason()
     * @uses DutchBusinessLeiBusinessEntity::setSuccessor()
     * @param string $company_name
     * @param string $legal_status
     * @param \StructType\DutchBusinessLeiLegalForm $legal_form
     * @param \StructType\DutchBusinessLeiAddress $headquarters_address
     * @param \StructType\DutchBusinessLeiAddress $legal_address
     * @param \StructType\DutchBusinessLeiRegistrationAuthority $registration_authority
     * @param string $expiration_date
     * @param string $expiration_reason
     * @param \StructType\DutchBusinessLeiSuccessor $successor
     */
    public function __construct($company_name = null, $legal_status = null, \StructType\DutchBusinessLeiLegalForm $legal_form = null, \StructType\DutchBusinessLeiAddress $headquarters_address = null, \StructType\DutchBusinessLeiAddress $legal_address = null, \StructType\DutchBusinessLeiRegistrationAuthority $registration_authority = null, $expiration_date = null, $expiration_reason = null, \StructType\DutchBusinessLeiSuccessor $successor = null)
    {
        $this
            ->setCompany_name($company_name)
            ->setLegal_status($legal_status)
            ->setLegal_form($legal_form)
            ->setHeadquarters_address($headquarters_address)
            ->setLegal_address($legal_address)
            ->setRegistration_authority($registration_authority)
            ->setExpiration_date($expiration_date)
            ->setExpiration_reason($expiration_reason)
            ->setSuccessor($successor);
    }
    /**
     * Get company_name value
     * @return string
     */
    public function getCompany_name()
    {
        return $this->company_name;
    }
    /**
     * Set company_name value
     * @param string $company_name
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setCompany_name($company_name = null)
    {
        // validation for constraint: string
        if (!is_null($company_name) && !is_string($company_name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($company_name, true), gettype($company_name)), __LINE__);
        }
        $this->company_name = $company_name;
        return $this;
    }
    /**
     * Get legal_status value
     * @return string
     */
    public function getLegal_status()
    {
        return $this->legal_status;
    }
    /**
     * Set legal_status value
     * @param string $legal_status
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setLegal_status($legal_status = null)
    {
        // validation for constraint: string
        if (!is_null($legal_status) && !is_string($legal_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($legal_status, true), gettype($legal_status)), __LINE__);
        }
        $this->legal_status = $legal_status;
        return $this;
    }
    /**
     * Get legal_form value
     * @return \StructType\DutchBusinessLeiLegalForm
     */
    public function getLegal_form()
    {
        return $this->legal_form;
    }
    /**
     * Set legal_form value
     * @param \StructType\DutchBusinessLeiLegalForm $legal_form
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setLegal_form(\StructType\DutchBusinessLeiLegalForm $legal_form = null)
    {
        $this->legal_form = $legal_form;
        return $this;
    }
    /**
     * Get headquarters_address value
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function getHeadquarters_address()
    {
        return $this->headquarters_address;
    }
    /**
     * Set headquarters_address value
     * @param \StructType\DutchBusinessLeiAddress $headquarters_address
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setHeadquarters_address(\StructType\DutchBusinessLeiAddress $headquarters_address = null)
    {
        $this->headquarters_address = $headquarters_address;
        return $this;
    }
    /**
     * Get legal_address value
     * @return \StructType\DutchBusinessLeiAddress
     */
    public function getLegal_address()
    {
        return $this->legal_address;
    }
    /**
     * Set legal_address value
     * @param \StructType\DutchBusinessLeiAddress $legal_address
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setLegal_address(\StructType\DutchBusinessLeiAddress $legal_address = null)
    {
        $this->legal_address = $legal_address;
        return $this;
    }
    /**
     * Get registration_authority value
     * @return \StructType\DutchBusinessLeiRegistrationAuthority
     */
    public function getRegistration_authority()
    {
        return $this->registration_authority;
    }
    /**
     * Set registration_authority value
     * @param \StructType\DutchBusinessLeiRegistrationAuthority $registration_authority
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setRegistration_authority(\StructType\DutchBusinessLeiRegistrationAuthority $registration_authority = null)
    {
        $this->registration_authority = $registration_authority;
        return $this;
    }
    /**
     * Get expiration_date value
     * @return string|null
     */
    public function getExpiration_date()
    {
        return $this->expiration_date;
    }
    /**
     * Set expiration_date value
     * @param string $expiration_date
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setExpiration_date($expiration_date = null)
    {
        // validation for constraint: string
        if (!is_null($expiration_date) && !is_string($expiration_date)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiration_date, true), gettype($expiration_date)), __LINE__);
        }
        $this->expiration_date = $expiration_date;
        return $this;
    }
    /**
     * Get expiration_reason value
     * @return string|null
     */
    public function getExpiration_reason()
    {
        return $this->expiration_reason;
    }
    /**
     * Set expiration_reason value
     * @param string $expiration_reason
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setExpiration_reason($expiration_reason = null)
    {
        // validation for constraint: string
        if (!is_null($expiration_reason) && !is_string($expiration_reason)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expiration_reason, true), gettype($expiration_reason)), __LINE__);
        }
        $this->expiration_reason = $expiration_reason;
        return $this;
    }
    /**
     * Get successor value
     * @return \StructType\DutchBusinessLeiSuccessor|null
     */
    public function getSuccessor()
    {
        return $this->successor;
    }
    /**
     * Set successor value
     * @param \StructType\DutchBusinessLeiSuccessor $successor
     * @return \StructType\DutchBusinessLeiBusinessEntity
     */
    public function setSuccessor(\StructType\DutchBusinessLeiSuccessor $successor = null)
    {
        $this->successor = $successor;
        return $this;
    }
}
