<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DutchBusinessLookALikeCompany StructType
 * @subpackage Structs
 */
class DutchBusinessLookALikeCompany extends AbstractStructBase
{
    /**
     * The dossier_number
     * @var string
     */
    public $dossier_number;
    /**
     * The name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $name;
    /**
     * The similarity_score
     * @var float
     */
    public $similarity_score;
    /**
     * The individual_features
     * @var \ArrayType\DutchBusinessLookALikeIndividualFeatureArray
     */
    public $individual_features;
    /**
     * The profile_url
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $profile_url;
    /**
     * Constructor method for DutchBusinessLookALikeCompany
     * @uses DutchBusinessLookALikeCompany::setDossier_number()
     * @uses DutchBusinessLookALikeCompany::setName()
     * @uses DutchBusinessLookALikeCompany::setSimilarity_score()
     * @uses DutchBusinessLookALikeCompany::setIndividual_features()
     * @uses DutchBusinessLookALikeCompany::setProfile_url()
     * @param string $dossier_number
     * @param string $name
     * @param float $similarity_score
     * @param \ArrayType\DutchBusinessLookALikeIndividualFeatureArray $individual_features
     * @param string $profile_url
     */
    public function __construct($dossier_number = null, $name = null, $similarity_score = null, \ArrayType\DutchBusinessLookALikeIndividualFeatureArray $individual_features = null, $profile_url = null)
    {
        $this
            ->setDossier_number($dossier_number)
            ->setName($name)
            ->setSimilarity_score($similarity_score)
            ->setIndividual_features($individual_features)
            ->setProfile_url($profile_url);
    }
    /**
     * Get dossier_number value
     * @return string|null
     */
    public function getDossier_number()
    {
        return $this->dossier_number;
    }
    /**
     * Set dossier_number value
     * @param string $dossier_number
     * @return \StructType\DutchBusinessLookALikeCompany
     */
    public function setDossier_number($dossier_number = null)
    {
        // validation for constraint: string
        if (!is_null($dossier_number) && !is_string($dossier_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dossier_number, true), gettype($dossier_number)), __LINE__);
        }
        $this->dossier_number = $dossier_number;
        return $this;
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \StructType\DutchBusinessLookALikeCompany
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get similarity_score value
     * @return float|null
     */
    public function getSimilarity_score()
    {
        return $this->similarity_score;
    }
    /**
     * Set similarity_score value
     * @param float $similarity_score
     * @return \StructType\DutchBusinessLookALikeCompany
     */
    public function setSimilarity_score($similarity_score = null)
    {
        // validation for constraint: float
        if (!is_null($similarity_score) && !(is_float($similarity_score) || is_numeric($similarity_score))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($similarity_score, true), gettype($similarity_score)), __LINE__);
        }
        $this->similarity_score = $similarity_score;
        return $this;
    }
    /**
     * Get individual_features value
     * @return \ArrayType\DutchBusinessLookALikeIndividualFeatureArray|null
     */
    public function getIndividual_features()
    {
        return $this->individual_features;
    }
    /**
     * Set individual_features value
     * @param \ArrayType\DutchBusinessLookALikeIndividualFeatureArray $individual_features
     * @return \StructType\DutchBusinessLookALikeCompany
     */
    public function setIndividual_features(\ArrayType\DutchBusinessLookALikeIndividualFeatureArray $individual_features = null)
    {
        $this->individual_features = $individual_features;
        return $this;
    }
    /**
     * Get profile_url value
     * @return string|null
     */
    public function getProfile_url()
    {
        return $this->profile_url;
    }
    /**
     * Set profile_url value
     * @param string $profile_url
     * @return \StructType\DutchBusinessLookALikeCompany
     */
    public function setProfile_url($profile_url = null)
    {
        // validation for constraint: string
        if (!is_null($profile_url) && !is_string($profile_url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($profile_url, true), gettype($profile_url)), __LINE__);
        }
        $this->profile_url = $profile_url;
        return $this;
    }
}
