<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for dutchBusinessSearchSelectionSimpleRequestType StructType
 * @subpackage Structs
 */
class DutchBusinessSearchSelectionSimpleRequestType extends AbstractStructBase
{
    /**
     * The city
     * @var \ArrayType\StringArray
     */
    public $city;
    /**
     * The postcode
     * @var \ArrayType\StringArray
     */
    public $postcode;
    /**
     * The sbi
     * @var \ArrayType\StringArray
     */
    public $sbi;
    /**
     * The primary_sbi_only
     * @var bool
     */
    public $primary_sbi_only;
    /**
     * The legal_form
     * @var \ArrayType\IntArray
     */
    public $legal_form;
    /**
     * The employees_min
     * @var int
     */
    public $employees_min;
    /**
     * The employees_max
     * @var int
     */
    public $employees_max;
    /**
     * The economically_active
     * @var string
     */
    public $economically_active;
    /**
     * The financial_status
     * @var string
     */
    public $financial_status;
    /**
     * The changed_since
     * @var string
     */
    public $changed_since;
    /**
     * The new_since
     * @var string
     */
    public $new_since;
    /**
     * The page
     * @var int
     */
    public $page;
    /**
     * The provinces
     * @var \ArrayType\StringArray
     */
    public $provinces;
    /**
     * Constructor method for dutchBusinessSearchSelectionSimpleRequestType
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setCity()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setPostcode()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setSbi()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setPrimary_sbi_only()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setLegal_form()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setEmployees_min()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setEmployees_max()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setEconomically_active()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setFinancial_status()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setChanged_since()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setNew_since()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setPage()
     * @uses DutchBusinessSearchSelectionSimpleRequestType::setProvinces()
     * @param \ArrayType\StringArray $city
     * @param \ArrayType\StringArray $postcode
     * @param \ArrayType\StringArray $sbi
     * @param bool $primary_sbi_only
     * @param \ArrayType\IntArray $legal_form
     * @param int $employees_min
     * @param int $employees_max
     * @param string $economically_active
     * @param string $financial_status
     * @param string $changed_since
     * @param string $new_since
     * @param int $page
     * @param \ArrayType\StringArray $provinces
     */
    public function __construct(\ArrayType\StringArray $city = null, \ArrayType\StringArray $postcode = null, \ArrayType\StringArray $sbi = null, $primary_sbi_only = null, \ArrayType\IntArray $legal_form = null, $employees_min = null, $employees_max = null, $economically_active = null, $financial_status = null, $changed_since = null, $new_since = null, $page = null, \ArrayType\StringArray $provinces = null)
    {
        $this
            ->setCity($city)
            ->setPostcode($postcode)
            ->setSbi($sbi)
            ->setPrimary_sbi_only($primary_sbi_only)
            ->setLegal_form($legal_form)
            ->setEmployees_min($employees_min)
            ->setEmployees_max($employees_max)
            ->setEconomically_active($economically_active)
            ->setFinancial_status($financial_status)
            ->setChanged_since($changed_since)
            ->setNew_since($new_since)
            ->setPage($page)
            ->setProvinces($provinces);
    }
    /**
     * Get city value
     * @return \ArrayType\StringArray|null
     */
    public function getCity()
    {
        return $this->city;
    }
    /**
     * Set city value
     * @param \ArrayType\StringArray $city
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setCity(\ArrayType\StringArray $city = null)
    {
        $this->city = $city;
        return $this;
    }
    /**
     * Get postcode value
     * @return \ArrayType\StringArray|null
     */
    public function getPostcode()
    {
        return $this->postcode;
    }
    /**
     * Set postcode value
     * @param \ArrayType\StringArray $postcode
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setPostcode(\ArrayType\StringArray $postcode = null)
    {
        $this->postcode = $postcode;
        return $this;
    }
    /**
     * Get sbi value
     * @return \ArrayType\StringArray|null
     */
    public function getSbi()
    {
        return $this->sbi;
    }
    /**
     * Set sbi value
     * @param \ArrayType\StringArray $sbi
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setSbi(\ArrayType\StringArray $sbi = null)
    {
        $this->sbi = $sbi;
        return $this;
    }
    /**
     * Get primary_sbi_only value
     * @return bool|null
     */
    public function getPrimary_sbi_only()
    {
        return $this->primary_sbi_only;
    }
    /**
     * Set primary_sbi_only value
     * @param bool $primary_sbi_only
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setPrimary_sbi_only($primary_sbi_only = null)
    {
        // validation for constraint: boolean
        if (!is_null($primary_sbi_only) && !is_bool($primary_sbi_only)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($primary_sbi_only, true), gettype($primary_sbi_only)), __LINE__);
        }
        $this->primary_sbi_only = $primary_sbi_only;
        return $this;
    }
    /**
     * Get legal_form value
     * @return \ArrayType\IntArray|null
     */
    public function getLegal_form()
    {
        return $this->legal_form;
    }
    /**
     * Set legal_form value
     * @param \ArrayType\IntArray $legal_form
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setLegal_form(\ArrayType\IntArray $legal_form = null)
    {
        $this->legal_form = $legal_form;
        return $this;
    }
    /**
     * Get employees_min value
     * @return int|null
     */
    public function getEmployees_min()
    {
        return $this->employees_min;
    }
    /**
     * Set employees_min value
     * @param int $employees_min
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setEmployees_min($employees_min = null)
    {
        // validation for constraint: int
        if (!is_null($employees_min) && !(is_int($employees_min) || ctype_digit($employees_min))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($employees_min, true), gettype($employees_min)), __LINE__);
        }
        $this->employees_min = $employees_min;
        return $this;
    }
    /**
     * Get employees_max value
     * @return int|null
     */
    public function getEmployees_max()
    {
        return $this->employees_max;
    }
    /**
     * Set employees_max value
     * @param int $employees_max
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setEmployees_max($employees_max = null)
    {
        // validation for constraint: int
        if (!is_null($employees_max) && !(is_int($employees_max) || ctype_digit($employees_max))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($employees_max, true), gettype($employees_max)), __LINE__);
        }
        $this->employees_max = $employees_max;
        return $this;
    }
    /**
     * Get economically_active value
     * @return string|null
     */
    public function getEconomically_active()
    {
        return $this->economically_active;
    }
    /**
     * Set economically_active value
     * @param string $economically_active
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setEconomically_active($economically_active = null)
    {
        // validation for constraint: string
        if (!is_null($economically_active) && !is_string($economically_active)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($economically_active, true), gettype($economically_active)), __LINE__);
        }
        $this->economically_active = $economically_active;
        return $this;
    }
    /**
     * Get financial_status value
     * @return string|null
     */
    public function getFinancial_status()
    {
        return $this->financial_status;
    }
    /**
     * Set financial_status value
     * @param string $financial_status
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setFinancial_status($financial_status = null)
    {
        // validation for constraint: string
        if (!is_null($financial_status) && !is_string($financial_status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($financial_status, true), gettype($financial_status)), __LINE__);
        }
        $this->financial_status = $financial_status;
        return $this;
    }
    /**
     * Get changed_since value
     * @return string|null
     */
    public function getChanged_since()
    {
        return $this->changed_since;
    }
    /**
     * Set changed_since value
     * @param string $changed_since
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setChanged_since($changed_since = null)
    {
        // validation for constraint: string
        if (!is_null($changed_since) && !is_string($changed_since)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($changed_since, true), gettype($changed_since)), __LINE__);
        }
        $this->changed_since = $changed_since;
        return $this;
    }
    /**
     * Get new_since value
     * @return string|null
     */
    public function getNew_since()
    {
        return $this->new_since;
    }
    /**
     * Set new_since value
     * @param string $new_since
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setNew_since($new_since = null)
    {
        // validation for constraint: string
        if (!is_null($new_since) && !is_string($new_since)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($new_since, true), gettype($new_since)), __LINE__);
        }
        $this->new_since = $new_since;
        return $this;
    }
    /**
     * Get page value
     * @return int|null
     */
    public function getPage()
    {
        return $this->page;
    }
    /**
     * Set page value
     * @param int $page
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setPage($page = null)
    {
        // validation for constraint: int
        if (!is_null($page) && !(is_int($page) || ctype_digit($page))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($page, true), gettype($page)), __LINE__);
        }
        $this->page = $page;
        return $this;
    }
    /**
     * Get provinces value
     * @return \ArrayType\StringArray|null
     */
    public function getProvinces()
    {
        return $this->provinces;
    }
    /**
     * Set provinces value
     * @param \ArrayType\StringArray $provinces
     * @return \StructType\DutchBusinessSearchSelectionSimpleRequestType
     */
    public function setProvinces(\ArrayType\StringArray $provinces = null)
    {
        $this->provinces = $provinces;
        return $this;
    }
}
