<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GraydonCreditReport StructType
 * @subpackage Structs
 */
class GraydonCreditReport extends AbstractStructBase
{
    /**
     * The report_normal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GraydonCreditReportNormal
     */
    public $report_normal;
    /**
     * The report_calamity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GraydonCreditReportCalamity
     */
    public $report_calamity;
    /**
     * The report_alarm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GraydonCreditReportAlarm
     */
    public $report_alarm;
    /**
     * The document
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $document;
    /**
     * The alarm
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\GCRAlarm
     */
    public $alarm;
    /**
     * Constructor method for GraydonCreditReport
     * @uses GraydonCreditReport::setReport_normal()
     * @uses GraydonCreditReport::setReport_calamity()
     * @uses GraydonCreditReport::setReport_alarm()
     * @uses GraydonCreditReport::setDocument()
     * @uses GraydonCreditReport::setAlarm()
     * @param \StructType\GraydonCreditReportNormal $report_normal
     * @param \StructType\GraydonCreditReportCalamity $report_calamity
     * @param \StructType\GraydonCreditReportAlarm $report_alarm
     * @param string $document
     * @param \StructType\GCRAlarm $alarm
     */
    public function __construct(\StructType\GraydonCreditReportNormal $report_normal = null, \StructType\GraydonCreditReportCalamity $report_calamity = null, \StructType\GraydonCreditReportAlarm $report_alarm = null, $document = null, \StructType\GCRAlarm $alarm = null)
    {
        $this
            ->setReport_normal($report_normal)
            ->setReport_calamity($report_calamity)
            ->setReport_alarm($report_alarm)
            ->setDocument($document)
            ->setAlarm($alarm);
    }
    /**
     * Get report_normal value
     * @return \StructType\GraydonCreditReportNormal|null
     */
    public function getReport_normal()
    {
        return $this->report_normal;
    }
    /**
     * Set report_normal value
     * @param \StructType\GraydonCreditReportNormal $report_normal
     * @return \StructType\GraydonCreditReport
     */
    public function setReport_normal(\StructType\GraydonCreditReportNormal $report_normal = null)
    {
        $this->report_normal = $report_normal;
        return $this;
    }
    /**
     * Get report_calamity value
     * @return \StructType\GraydonCreditReportCalamity|null
     */
    public function getReport_calamity()
    {
        return $this->report_calamity;
    }
    /**
     * Set report_calamity value
     * @param \StructType\GraydonCreditReportCalamity $report_calamity
     * @return \StructType\GraydonCreditReport
     */
    public function setReport_calamity(\StructType\GraydonCreditReportCalamity $report_calamity = null)
    {
        $this->report_calamity = $report_calamity;
        return $this;
    }
    /**
     * Get report_alarm value
     * @return \StructType\GraydonCreditReportAlarm|null
     */
    public function getReport_alarm()
    {
        return $this->report_alarm;
    }
    /**
     * Set report_alarm value
     * @param \StructType\GraydonCreditReportAlarm $report_alarm
     * @return \StructType\GraydonCreditReport
     */
    public function setReport_alarm(\StructType\GraydonCreditReportAlarm $report_alarm = null)
    {
        $this->report_alarm = $report_alarm;
        return $this;
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\GraydonCreditReport
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Get alarm value
     * @return \StructType\GCRAlarm|null
     */
    public function getAlarm()
    {
        return $this->alarm;
    }
    /**
     * Set alarm value
     * @param \StructType\GCRAlarm $alarm
     * @return \StructType\GraydonCreditReport
     */
    public function setAlarm(\StructType\GCRAlarm $alarm = null)
    {
        $this->alarm = $alarm;
        return $this;
    }
}
