<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kadasterBedrag StructType
 * @subpackage Structs
 */
class KadasterBedrag extends AbstractStructBase
{
    /**
     * The valuta
     * @var string
     */
    public $valuta;
    /**
     * The bedrag
     * @var int
     */
    public $bedrag;
    /**
     * Constructor method for kadasterBedrag
     * @uses KadasterBedrag::setValuta()
     * @uses KadasterBedrag::setBedrag()
     * @param string $valuta
     * @param int $bedrag
     */
    public function __construct($valuta = null, $bedrag = null)
    {
        $this
            ->setValuta($valuta)
            ->setBedrag($bedrag);
    }
    /**
     * Get valuta value
     * @return string|null
     */
    public function getValuta()
    {
        return $this->valuta;
    }
    /**
     * Set valuta value
     * @param string $valuta
     * @return \StructType\KadasterBedrag
     */
    public function setValuta($valuta = null)
    {
        // validation for constraint: string
        if (!is_null($valuta) && !is_string($valuta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valuta, true), gettype($valuta)), __LINE__);
        }
        $this->valuta = $valuta;
        return $this;
    }
    /**
     * Get bedrag value
     * @return int|null
     */
    public function getBedrag()
    {
        return $this->bedrag;
    }
    /**
     * Set bedrag value
     * @param int $bedrag
     * @return \StructType\KadasterBedrag
     */
    public function setBedrag($bedrag = null)
    {
        // validation for constraint: int
        if (!is_null($bedrag) && !(is_int($bedrag) || ctype_digit($bedrag))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($bedrag, true), gettype($bedrag)), __LINE__);
        }
        $this->bedrag = $bedrag;
        return $this;
    }
}
