<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for kadasterBerichtObjectDocument StructType
 * @subpackage Structs
 */
class KadasterBerichtObjectDocument extends AbstractStructBase
{
    /**
     * The document
     * @var string
     */
    public $document;
    /**
     * The afbeeldingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\Base64BinaryArray
     */
    public $afbeeldingen;
    /**
     * Constructor method for kadasterBerichtObjectDocument
     * @uses KadasterBerichtObjectDocument::setDocument()
     * @uses KadasterBerichtObjectDocument::setAfbeeldingen()
     * @param string $document
     * @param \ArrayType\Base64BinaryArray $afbeeldingen
     */
    public function __construct($document = null, \ArrayType\Base64BinaryArray $afbeeldingen = null)
    {
        $this
            ->setDocument($document)
            ->setAfbeeldingen($afbeeldingen);
    }
    /**
     * Get document value
     * @return string|null
     */
    public function getDocument()
    {
        return $this->document;
    }
    /**
     * Set document value
     * @param string $document
     * @return \StructType\KadasterBerichtObjectDocument
     */
    public function setDocument($document = null)
    {
        // validation for constraint: string
        if (!is_null($document) && !is_string($document)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($document, true), gettype($document)), __LINE__);
        }
        $this->document = $document;
        return $this;
    }
    /**
     * Get afbeeldingen value
     * @return \ArrayType\Base64BinaryArray|null
     */
    public function getAfbeeldingen()
    {
        return $this->afbeeldingen;
    }
    /**
     * Set afbeeldingen value
     * @param \ArrayType\Base64BinaryArray $afbeeldingen
     * @return \StructType\KadasterBerichtObjectDocument
     */
    public function setAfbeeldingen(\ArrayType\Base64BinaryArray $afbeeldingen = null)
    {
        $this->afbeeldingen = $afbeeldingen;
        return $this;
    }
}
