<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2HypothecairBericht StructType
 * @subpackage Structs
 */
class KadasterV2HypothecairBericht extends AbstractStructBase
{
    /**
     * The productienummer
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $productienummer;
    /**
     * The tijdstip_samenstelling_bericht
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $tijdstip_samenstelling_bericht;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\KadasterV2OnroerendeZaak
     */
    public $betreft;
    /**
     * The stukken
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\KadasterV2Stukken
     */
    public $stukken;
    /**
     * The actualiteit_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_hypothecair;
    /**
     * The actualiteit_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_kadastraal;
    /**
     * The signalering_tijdstip_beslagen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_beslagen;
    /**
     * The signalering_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_hypothecair;
    /**
     * The signalering_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_kadastraal;
    /**
     * The hypotheken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2HypotheekArray
     */
    public $hypotheken;
    /**
     * The beslagleggingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2BeslagleggingArray
     */
    public $beslagleggingen;
    /**
     * The zakelijk_rechten
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2ZakelijkRechtArray
     */
    public $zakelijk_rechten;
    /**
     * The aantekeningen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2AantekeningArray
     */
    public $aantekeningen;
    /**
     * Constructor method for KadasterV2HypothecairBericht
     * @uses KadasterV2HypothecairBericht::setProductienummer()
     * @uses KadasterV2HypothecairBericht::setTijdstip_samenstelling_bericht()
     * @uses KadasterV2HypothecairBericht::setBetreft()
     * @uses KadasterV2HypothecairBericht::setStukken()
     * @uses KadasterV2HypothecairBericht::setActualiteit_tijdstip_hypothecair()
     * @uses KadasterV2HypothecairBericht::setActualiteit_tijdstip_kadastraal()
     * @uses KadasterV2HypothecairBericht::setSignalering_tijdstip_beslagen()
     * @uses KadasterV2HypothecairBericht::setSignalering_tijdstip_hypothecair()
     * @uses KadasterV2HypothecairBericht::setSignalering_tijdstip_kadastraal()
     * @uses KadasterV2HypothecairBericht::setHypotheken()
     * @uses KadasterV2HypothecairBericht::setBeslagleggingen()
     * @uses KadasterV2HypothecairBericht::setZakelijk_rechten()
     * @uses KadasterV2HypothecairBericht::setAantekeningen()
     * @param string $productienummer
     * @param string $tijdstip_samenstelling_bericht
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @param \StructType\KadasterV2Stukken $stukken
     * @param string $actualiteit_tijdstip_hypothecair
     * @param string $actualiteit_tijdstip_kadastraal
     * @param string $signalering_tijdstip_beslagen
     * @param string $signalering_tijdstip_hypothecair
     * @param string $signalering_tijdstip_kadastraal
     * @param \ArrayType\KadasterV2HypotheekArray $hypotheken
     * @param \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten
     * @param \ArrayType\KadasterV2AantekeningArray $aantekeningen
     */
    public function __construct($productienummer = null, $tijdstip_samenstelling_bericht = null, \StructType\KadasterV2OnroerendeZaak $betreft = null, \StructType\KadasterV2Stukken $stukken = null, $actualiteit_tijdstip_hypothecair = null, $actualiteit_tijdstip_kadastraal = null, $signalering_tijdstip_beslagen = null, $signalering_tijdstip_hypothecair = null, $signalering_tijdstip_kadastraal = null, \ArrayType\KadasterV2HypotheekArray $hypotheken = null, \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen = null, \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten = null, \ArrayType\KadasterV2AantekeningArray $aantekeningen = null)
    {
        $this
            ->setProductienummer($productienummer)
            ->setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht)
            ->setBetreft($betreft)
            ->setStukken($stukken)
            ->setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair)
            ->setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal)
            ->setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen)
            ->setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair)
            ->setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal)
            ->setHypotheken($hypotheken)
            ->setBeslagleggingen($beslagleggingen)
            ->setZakelijk_rechten($zakelijk_rechten)
            ->setAantekeningen($aantekeningen);
    }
    /**
     * Get productienummer value
     * @return string
     */
    public function getProductienummer()
    {
        return $this->productienummer;
    }
    /**
     * Set productienummer value
     * @param string $productienummer
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setProductienummer($productienummer = null)
    {
        // validation for constraint: string
        if (!is_null($productienummer) && !is_string($productienummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productienummer, true), gettype($productienummer)), __LINE__);
        }
        $this->productienummer = $productienummer;
        return $this;
    }
    /**
     * Get tijdstip_samenstelling_bericht value
     * @return string
     */
    public function getTijdstip_samenstelling_bericht()
    {
        return $this->tijdstip_samenstelling_bericht;
    }
    /**
     * Set tijdstip_samenstelling_bericht value
     * @param string $tijdstip_samenstelling_bericht
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht = null)
    {
        // validation for constraint: string
        if (!is_null($tijdstip_samenstelling_bericht) && !is_string($tijdstip_samenstelling_bericht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tijdstip_samenstelling_bericht, true), gettype($tijdstip_samenstelling_bericht)), __LINE__);
        }
        $this->tijdstip_samenstelling_bericht = $tijdstip_samenstelling_bericht;
        return $this;
    }
    /**
     * Get betreft value
     * @return \StructType\KadasterV2OnroerendeZaak
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setBetreft(\StructType\KadasterV2OnroerendeZaak $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
    /**
     * Get stukken value
     * @return \StructType\KadasterV2Stukken
     */
    public function getStukken()
    {
        return $this->stukken;
    }
    /**
     * Set stukken value
     * @param \StructType\KadasterV2Stukken $stukken
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setStukken(\StructType\KadasterV2Stukken $stukken = null)
    {
        $this->stukken = $stukken;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_hypothecair value
     * @return string|null
     */
    public function getActualiteit_tijdstip_hypothecair()
    {
        return $this->actualiteit_tijdstip_hypothecair;
    }
    /**
     * Set actualiteit_tijdstip_hypothecair value
     * @param string $actualiteit_tijdstip_hypothecair
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_hypothecair) && !is_string($actualiteit_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_hypothecair, true), gettype($actualiteit_tijdstip_hypothecair)), __LINE__);
        }
        $this->actualiteit_tijdstip_hypothecair = $actualiteit_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_kadastraal value
     * @return string|null
     */
    public function getActualiteit_tijdstip_kadastraal()
    {
        return $this->actualiteit_tijdstip_kadastraal;
    }
    /**
     * Set actualiteit_tijdstip_kadastraal value
     * @param string $actualiteit_tijdstip_kadastraal
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_kadastraal) && !is_string($actualiteit_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_kadastraal, true), gettype($actualiteit_tijdstip_kadastraal)), __LINE__);
        }
        $this->actualiteit_tijdstip_kadastraal = $actualiteit_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Get signalering_tijdstip_beslagen value
     * @return string|null
     */
    public function getSignalering_tijdstip_beslagen()
    {
        return $this->signalering_tijdstip_beslagen;
    }
    /**
     * Set signalering_tijdstip_beslagen value
     * @param string $signalering_tijdstip_beslagen
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_beslagen) && !is_string($signalering_tijdstip_beslagen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_beslagen, true), gettype($signalering_tijdstip_beslagen)), __LINE__);
        }
        $this->signalering_tijdstip_beslagen = $signalering_tijdstip_beslagen;
        return $this;
    }
    /**
     * Get signalering_tijdstip_hypothecair value
     * @return string|null
     */
    public function getSignalering_tijdstip_hypothecair()
    {
        return $this->signalering_tijdstip_hypothecair;
    }
    /**
     * Set signalering_tijdstip_hypothecair value
     * @param string $signalering_tijdstip_hypothecair
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_hypothecair) && !is_string($signalering_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_hypothecair, true), gettype($signalering_tijdstip_hypothecair)), __LINE__);
        }
        $this->signalering_tijdstip_hypothecair = $signalering_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get signalering_tijdstip_kadastraal value
     * @return string|null
     */
    public function getSignalering_tijdstip_kadastraal()
    {
        return $this->signalering_tijdstip_kadastraal;
    }
    /**
     * Set signalering_tijdstip_kadastraal value
     * @param string $signalering_tijdstip_kadastraal
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_kadastraal) && !is_string($signalering_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_kadastraal, true), gettype($signalering_tijdstip_kadastraal)), __LINE__);
        }
        $this->signalering_tijdstip_kadastraal = $signalering_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Get hypotheken value
     * @return \ArrayType\KadasterV2HypotheekArray|null
     */
    public function getHypotheken()
    {
        return $this->hypotheken;
    }
    /**
     * Set hypotheken value
     * @param \ArrayType\KadasterV2HypotheekArray $hypotheken
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setHypotheken(\ArrayType\KadasterV2HypotheekArray $hypotheken = null)
    {
        $this->hypotheken = $hypotheken;
        return $this;
    }
    /**
     * Get beslagleggingen value
     * @return \ArrayType\KadasterV2BeslagleggingArray|null
     */
    public function getBeslagleggingen()
    {
        return $this->beslagleggingen;
    }
    /**
     * Set beslagleggingen value
     * @param \ArrayType\KadasterV2BeslagleggingArray $beslagleggingen
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setBeslagleggingen(\ArrayType\KadasterV2BeslagleggingArray $beslagleggingen = null)
    {
        $this->beslagleggingen = $beslagleggingen;
        return $this;
    }
    /**
     * Get zakelijk_rechten value
     * @return \ArrayType\KadasterV2ZakelijkRechtArray|null
     */
    public function getZakelijk_rechten()
    {
        return $this->zakelijk_rechten;
    }
    /**
     * Set zakelijk_rechten value
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setZakelijk_rechten(\ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten = null)
    {
        $this->zakelijk_rechten = $zakelijk_rechten;
        return $this;
    }
    /**
     * Get aantekeningen value
     * @return \ArrayType\KadasterV2AantekeningArray|null
     */
    public function getAantekeningen()
    {
        return $this->aantekeningen;
    }
    /**
     * Set aantekeningen value
     * @param \ArrayType\KadasterV2AantekeningArray $aantekeningen
     * @return \StructType\KadasterV2HypothecairBericht
     */
    public function setAantekeningen(\ArrayType\KadasterV2AantekeningArray $aantekeningen = null)
    {
        $this->aantekeningen = $aantekeningen;
        return $this;
    }
}
