<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2KadastraalBericht StructType
 * @subpackage Structs
 */
class KadasterV2KadastraalBericht extends AbstractStructBase
{
    /**
     * The productienummer
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $productienummer;
    /**
     * The tijdstip_samenstelling_bericht
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var string
     */
    public $tijdstip_samenstelling_bericht;
    /**
     * The betreft
     * Meta information extracted from the WSDL
     * - minOccurs: 1
     * @var \StructType\KadasterV2OnroerendeZaak
     */
    public $betreft;
    /**
     * The actualiteit_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_hypothecair;
    /**
     * The actualiteit_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $actualiteit_tijdstip_kadastraal;
    /**
     * The signalering_tijdstip_beslagen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_beslagen;
    /**
     * The signalering_tijdstip_hypothecair
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_hypothecair;
    /**
     * The signalering_tijdstip_kadastraal
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signalering_tijdstip_kadastraal;
    /**
     * The tenaamstellingen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2TenaamstellingArray
     */
    public $tenaamstellingen;
    /**
     * The zakelijk_rechten
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2ZakelijkRechtArray
     */
    public $zakelijk_rechten;
    /**
     * The aantekeningen
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2AantekeningArray
     */
    public $aantekeningen;
    /**
     * The erfpachtcanon
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2ErfpachtCanonArray
     */
    public $erfpachtcanon;
    /**
     * The stukken
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Stukken
     */
    public $stukken;
    /**
     * Constructor method for KadasterV2KadastraalBericht
     * @uses KadasterV2KadastraalBericht::setProductienummer()
     * @uses KadasterV2KadastraalBericht::setTijdstip_samenstelling_bericht()
     * @uses KadasterV2KadastraalBericht::setBetreft()
     * @uses KadasterV2KadastraalBericht::setActualiteit_tijdstip_hypothecair()
     * @uses KadasterV2KadastraalBericht::setActualiteit_tijdstip_kadastraal()
     * @uses KadasterV2KadastraalBericht::setSignalering_tijdstip_beslagen()
     * @uses KadasterV2KadastraalBericht::setSignalering_tijdstip_hypothecair()
     * @uses KadasterV2KadastraalBericht::setSignalering_tijdstip_kadastraal()
     * @uses KadasterV2KadastraalBericht::setTenaamstellingen()
     * @uses KadasterV2KadastraalBericht::setZakelijk_rechten()
     * @uses KadasterV2KadastraalBericht::setAantekeningen()
     * @uses KadasterV2KadastraalBericht::setErfpachtcanon()
     * @uses KadasterV2KadastraalBericht::setStukken()
     * @param string $productienummer
     * @param string $tijdstip_samenstelling_bericht
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @param string $actualiteit_tijdstip_hypothecair
     * @param string $actualiteit_tijdstip_kadastraal
     * @param string $signalering_tijdstip_beslagen
     * @param string $signalering_tijdstip_hypothecair
     * @param string $signalering_tijdstip_kadastraal
     * @param \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten
     * @param \ArrayType\KadasterV2AantekeningArray $aantekeningen
     * @param \ArrayType\KadasterV2ErfpachtCanonArray $erfpachtcanon
     * @param \StructType\KadasterV2Stukken $stukken
     */
    public function __construct($productienummer = null, $tijdstip_samenstelling_bericht = null, \StructType\KadasterV2OnroerendeZaak $betreft = null, $actualiteit_tijdstip_hypothecair = null, $actualiteit_tijdstip_kadastraal = null, $signalering_tijdstip_beslagen = null, $signalering_tijdstip_hypothecair = null, $signalering_tijdstip_kadastraal = null, \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen = null, \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten = null, \ArrayType\KadasterV2AantekeningArray $aantekeningen = null, \ArrayType\KadasterV2ErfpachtCanonArray $erfpachtcanon = null, \StructType\KadasterV2Stukken $stukken = null)
    {
        $this
            ->setProductienummer($productienummer)
            ->setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht)
            ->setBetreft($betreft)
            ->setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair)
            ->setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal)
            ->setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen)
            ->setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair)
            ->setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal)
            ->setTenaamstellingen($tenaamstellingen)
            ->setZakelijk_rechten($zakelijk_rechten)
            ->setAantekeningen($aantekeningen)
            ->setErfpachtcanon($erfpachtcanon)
            ->setStukken($stukken);
    }
    /**
     * Get productienummer value
     * @return string
     */
    public function getProductienummer()
    {
        return $this->productienummer;
    }
    /**
     * Set productienummer value
     * @param string $productienummer
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setProductienummer($productienummer = null)
    {
        // validation for constraint: string
        if (!is_null($productienummer) && !is_string($productienummer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productienummer, true), gettype($productienummer)), __LINE__);
        }
        $this->productienummer = $productienummer;
        return $this;
    }
    /**
     * Get tijdstip_samenstelling_bericht value
     * @return string
     */
    public function getTijdstip_samenstelling_bericht()
    {
        return $this->tijdstip_samenstelling_bericht;
    }
    /**
     * Set tijdstip_samenstelling_bericht value
     * @param string $tijdstip_samenstelling_bericht
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setTijdstip_samenstelling_bericht($tijdstip_samenstelling_bericht = null)
    {
        // validation for constraint: string
        if (!is_null($tijdstip_samenstelling_bericht) && !is_string($tijdstip_samenstelling_bericht)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tijdstip_samenstelling_bericht, true), gettype($tijdstip_samenstelling_bericht)), __LINE__);
        }
        $this->tijdstip_samenstelling_bericht = $tijdstip_samenstelling_bericht;
        return $this;
    }
    /**
     * Get betreft value
     * @return \StructType\KadasterV2OnroerendeZaak
     */
    public function getBetreft()
    {
        return $this->betreft;
    }
    /**
     * Set betreft value
     * @param \StructType\KadasterV2OnroerendeZaak $betreft
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setBetreft(\StructType\KadasterV2OnroerendeZaak $betreft = null)
    {
        $this->betreft = $betreft;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_hypothecair value
     * @return string|null
     */
    public function getActualiteit_tijdstip_hypothecair()
    {
        return $this->actualiteit_tijdstip_hypothecair;
    }
    /**
     * Set actualiteit_tijdstip_hypothecair value
     * @param string $actualiteit_tijdstip_hypothecair
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setActualiteit_tijdstip_hypothecair($actualiteit_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_hypothecair) && !is_string($actualiteit_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_hypothecair, true), gettype($actualiteit_tijdstip_hypothecair)), __LINE__);
        }
        $this->actualiteit_tijdstip_hypothecair = $actualiteit_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get actualiteit_tijdstip_kadastraal value
     * @return string|null
     */
    public function getActualiteit_tijdstip_kadastraal()
    {
        return $this->actualiteit_tijdstip_kadastraal;
    }
    /**
     * Set actualiteit_tijdstip_kadastraal value
     * @param string $actualiteit_tijdstip_kadastraal
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setActualiteit_tijdstip_kadastraal($actualiteit_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($actualiteit_tijdstip_kadastraal) && !is_string($actualiteit_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($actualiteit_tijdstip_kadastraal, true), gettype($actualiteit_tijdstip_kadastraal)), __LINE__);
        }
        $this->actualiteit_tijdstip_kadastraal = $actualiteit_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Get signalering_tijdstip_beslagen value
     * @return string|null
     */
    public function getSignalering_tijdstip_beslagen()
    {
        return $this->signalering_tijdstip_beslagen;
    }
    /**
     * Set signalering_tijdstip_beslagen value
     * @param string $signalering_tijdstip_beslagen
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setSignalering_tijdstip_beslagen($signalering_tijdstip_beslagen = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_beslagen) && !is_string($signalering_tijdstip_beslagen)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_beslagen, true), gettype($signalering_tijdstip_beslagen)), __LINE__);
        }
        $this->signalering_tijdstip_beslagen = $signalering_tijdstip_beslagen;
        return $this;
    }
    /**
     * Get signalering_tijdstip_hypothecair value
     * @return string|null
     */
    public function getSignalering_tijdstip_hypothecair()
    {
        return $this->signalering_tijdstip_hypothecair;
    }
    /**
     * Set signalering_tijdstip_hypothecair value
     * @param string $signalering_tijdstip_hypothecair
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setSignalering_tijdstip_hypothecair($signalering_tijdstip_hypothecair = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_hypothecair) && !is_string($signalering_tijdstip_hypothecair)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_hypothecair, true), gettype($signalering_tijdstip_hypothecair)), __LINE__);
        }
        $this->signalering_tijdstip_hypothecair = $signalering_tijdstip_hypothecair;
        return $this;
    }
    /**
     * Get signalering_tijdstip_kadastraal value
     * @return string|null
     */
    public function getSignalering_tijdstip_kadastraal()
    {
        return $this->signalering_tijdstip_kadastraal;
    }
    /**
     * Set signalering_tijdstip_kadastraal value
     * @param string $signalering_tijdstip_kadastraal
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setSignalering_tijdstip_kadastraal($signalering_tijdstip_kadastraal = null)
    {
        // validation for constraint: string
        if (!is_null($signalering_tijdstip_kadastraal) && !is_string($signalering_tijdstip_kadastraal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signalering_tijdstip_kadastraal, true), gettype($signalering_tijdstip_kadastraal)), __LINE__);
        }
        $this->signalering_tijdstip_kadastraal = $signalering_tijdstip_kadastraal;
        return $this;
    }
    /**
     * Get tenaamstellingen value
     * @return \ArrayType\KadasterV2TenaamstellingArray|null
     */
    public function getTenaamstellingen()
    {
        return $this->tenaamstellingen;
    }
    /**
     * Set tenaamstellingen value
     * @param \ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setTenaamstellingen(\ArrayType\KadasterV2TenaamstellingArray $tenaamstellingen = null)
    {
        $this->tenaamstellingen = $tenaamstellingen;
        return $this;
    }
    /**
     * Get zakelijk_rechten value
     * @return \ArrayType\KadasterV2ZakelijkRechtArray|null
     */
    public function getZakelijk_rechten()
    {
        return $this->zakelijk_rechten;
    }
    /**
     * Set zakelijk_rechten value
     * @param \ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setZakelijk_rechten(\ArrayType\KadasterV2ZakelijkRechtArray $zakelijk_rechten = null)
    {
        $this->zakelijk_rechten = $zakelijk_rechten;
        return $this;
    }
    /**
     * Get aantekeningen value
     * @return \ArrayType\KadasterV2AantekeningArray|null
     */
    public function getAantekeningen()
    {
        return $this->aantekeningen;
    }
    /**
     * Set aantekeningen value
     * @param \ArrayType\KadasterV2AantekeningArray $aantekeningen
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setAantekeningen(\ArrayType\KadasterV2AantekeningArray $aantekeningen = null)
    {
        $this->aantekeningen = $aantekeningen;
        return $this;
    }
    /**
     * Get erfpachtcanon value
     * @return \ArrayType\KadasterV2ErfpachtCanonArray|null
     */
    public function getErfpachtcanon()
    {
        return $this->erfpachtcanon;
    }
    /**
     * Set erfpachtcanon value
     * @param \ArrayType\KadasterV2ErfpachtCanonArray $erfpachtcanon
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setErfpachtcanon(\ArrayType\KadasterV2ErfpachtCanonArray $erfpachtcanon = null)
    {
        $this->erfpachtcanon = $erfpachtcanon;
        return $this;
    }
    /**
     * Get stukken value
     * @return \StructType\KadasterV2Stukken|null
     */
    public function getStukken()
    {
        return $this->stukken;
    }
    /**
     * Set stukken value
     * @param \StructType\KadasterV2Stukken $stukken
     * @return \StructType\KadasterV2KadastraalBericht
     */
    public function setStukken(\StructType\KadasterV2Stukken $stukken = null)
    {
        $this->stukken = $stukken;
        return $this;
    }
}
