<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KadasterV2Stukdeel StructType
 * @subpackage Structs
 */
class KadasterV2Stukdeel extends AbstractStructBase
{
    /**
     * The identificatie
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $identificatie;
    /**
     * The aard
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $aard;
    /**
     * The omschrijving_gekozen_woonplaats
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving_gekozen_woonplaats;
    /**
     * The omschrijving_kadastrale_objecten
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $omschrijving_kadastrale_objecten;
    /**
     * The bedrag_transacties_om_levering
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Bedrag
     */
    public $bedrag_transacties_om_levering;
    /**
     * The bedrag_vorderingsbeslag
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Bedrag
     */
    public $bedrag_vorderingsbeslag;
    /**
     * The bedrag_zekerheidsstelling_hypotheek
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\KadasterV2Bedrag
     */
    public $bedrag_zekerheidsstelling_hypotheek;
    /**
     * The aanvulling_op
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2StukdeelArray
     */
    public $aanvulling_op;
    /**
     * The vermeld_in
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \ArrayType\KadasterV2OnroerendeZaakReferenceArray
     */
    public $vermeld_in;
    /**
     * Constructor method for KadasterV2Stukdeel
     * @uses KadasterV2Stukdeel::setIdentificatie()
     * @uses KadasterV2Stukdeel::setAard()
     * @uses KadasterV2Stukdeel::setOmschrijving_gekozen_woonplaats()
     * @uses KadasterV2Stukdeel::setOmschrijving_kadastrale_objecten()
     * @uses KadasterV2Stukdeel::setBedrag_transacties_om_levering()
     * @uses KadasterV2Stukdeel::setBedrag_vorderingsbeslag()
     * @uses KadasterV2Stukdeel::setBedrag_zekerheidsstelling_hypotheek()
     * @uses KadasterV2Stukdeel::setAanvulling_op()
     * @uses KadasterV2Stukdeel::setVermeld_in()
     * @param string $identificatie
     * @param string $aard
     * @param string $omschrijving_gekozen_woonplaats
     * @param string $omschrijving_kadastrale_objecten
     * @param \StructType\KadasterV2Bedrag $bedrag_transacties_om_levering
     * @param \StructType\KadasterV2Bedrag $bedrag_vorderingsbeslag
     * @param \StructType\KadasterV2Bedrag $bedrag_zekerheidsstelling_hypotheek
     * @param \ArrayType\KadasterV2StukdeelArray $aanvulling_op
     * @param \ArrayType\KadasterV2OnroerendeZaakReferenceArray $vermeld_in
     */
    public function __construct($identificatie = null, $aard = null, $omschrijving_gekozen_woonplaats = null, $omschrijving_kadastrale_objecten = null, \StructType\KadasterV2Bedrag $bedrag_transacties_om_levering = null, \StructType\KadasterV2Bedrag $bedrag_vorderingsbeslag = null, \StructType\KadasterV2Bedrag $bedrag_zekerheidsstelling_hypotheek = null, \ArrayType\KadasterV2StukdeelArray $aanvulling_op = null, \ArrayType\KadasterV2OnroerendeZaakReferenceArray $vermeld_in = null)
    {
        $this
            ->setIdentificatie($identificatie)
            ->setAard($aard)
            ->setOmschrijving_gekozen_woonplaats($omschrijving_gekozen_woonplaats)
            ->setOmschrijving_kadastrale_objecten($omschrijving_kadastrale_objecten)
            ->setBedrag_transacties_om_levering($bedrag_transacties_om_levering)
            ->setBedrag_vorderingsbeslag($bedrag_vorderingsbeslag)
            ->setBedrag_zekerheidsstelling_hypotheek($bedrag_zekerheidsstelling_hypotheek)
            ->setAanvulling_op($aanvulling_op)
            ->setVermeld_in($vermeld_in);
    }
    /**
     * Get identificatie value
     * @return string|null
     */
    public function getIdentificatie()
    {
        return $this->identificatie;
    }
    /**
     * Set identificatie value
     * @param string $identificatie
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setIdentificatie($identificatie = null)
    {
        // validation for constraint: string
        if (!is_null($identificatie) && !is_string($identificatie)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($identificatie, true), gettype($identificatie)), __LINE__);
        }
        $this->identificatie = $identificatie;
        return $this;
    }
    /**
     * Get aard value
     * @return string|null
     */
    public function getAard()
    {
        return $this->aard;
    }
    /**
     * Set aard value
     * @param string $aard
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setAard($aard = null)
    {
        // validation for constraint: string
        if (!is_null($aard) && !is_string($aard)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aard, true), gettype($aard)), __LINE__);
        }
        $this->aard = $aard;
        return $this;
    }
    /**
     * Get omschrijving_gekozen_woonplaats value
     * @return string|null
     */
    public function getOmschrijving_gekozen_woonplaats()
    {
        return $this->omschrijving_gekozen_woonplaats;
    }
    /**
     * Set omschrijving_gekozen_woonplaats value
     * @param string $omschrijving_gekozen_woonplaats
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setOmschrijving_gekozen_woonplaats($omschrijving_gekozen_woonplaats = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving_gekozen_woonplaats) && !is_string($omschrijving_gekozen_woonplaats)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving_gekozen_woonplaats, true), gettype($omschrijving_gekozen_woonplaats)), __LINE__);
        }
        $this->omschrijving_gekozen_woonplaats = $omschrijving_gekozen_woonplaats;
        return $this;
    }
    /**
     * Get omschrijving_kadastrale_objecten value
     * @return string|null
     */
    public function getOmschrijving_kadastrale_objecten()
    {
        return $this->omschrijving_kadastrale_objecten;
    }
    /**
     * Set omschrijving_kadastrale_objecten value
     * @param string $omschrijving_kadastrale_objecten
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setOmschrijving_kadastrale_objecten($omschrijving_kadastrale_objecten = null)
    {
        // validation for constraint: string
        if (!is_null($omschrijving_kadastrale_objecten) && !is_string($omschrijving_kadastrale_objecten)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($omschrijving_kadastrale_objecten, true), gettype($omschrijving_kadastrale_objecten)), __LINE__);
        }
        $this->omschrijving_kadastrale_objecten = $omschrijving_kadastrale_objecten;
        return $this;
    }
    /**
     * Get bedrag_transacties_om_levering value
     * @return \StructType\KadasterV2Bedrag|null
     */
    public function getBedrag_transacties_om_levering()
    {
        return $this->bedrag_transacties_om_levering;
    }
    /**
     * Set bedrag_transacties_om_levering value
     * @param \StructType\KadasterV2Bedrag $bedrag_transacties_om_levering
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setBedrag_transacties_om_levering(\StructType\KadasterV2Bedrag $bedrag_transacties_om_levering = null)
    {
        $this->bedrag_transacties_om_levering = $bedrag_transacties_om_levering;
        return $this;
    }
    /**
     * Get bedrag_vorderingsbeslag value
     * @return \StructType\KadasterV2Bedrag|null
     */
    public function getBedrag_vorderingsbeslag()
    {
        return $this->bedrag_vorderingsbeslag;
    }
    /**
     * Set bedrag_vorderingsbeslag value
     * @param \StructType\KadasterV2Bedrag $bedrag_vorderingsbeslag
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setBedrag_vorderingsbeslag(\StructType\KadasterV2Bedrag $bedrag_vorderingsbeslag = null)
    {
        $this->bedrag_vorderingsbeslag = $bedrag_vorderingsbeslag;
        return $this;
    }
    /**
     * Get bedrag_zekerheidsstelling_hypotheek value
     * @return \StructType\KadasterV2Bedrag|null
     */
    public function getBedrag_zekerheidsstelling_hypotheek()
    {
        return $this->bedrag_zekerheidsstelling_hypotheek;
    }
    /**
     * Set bedrag_zekerheidsstelling_hypotheek value
     * @param \StructType\KadasterV2Bedrag $bedrag_zekerheidsstelling_hypotheek
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setBedrag_zekerheidsstelling_hypotheek(\StructType\KadasterV2Bedrag $bedrag_zekerheidsstelling_hypotheek = null)
    {
        $this->bedrag_zekerheidsstelling_hypotheek = $bedrag_zekerheidsstelling_hypotheek;
        return $this;
    }
    /**
     * Get aanvulling_op value
     * @return \ArrayType\KadasterV2StukdeelArray|null
     */
    public function getAanvulling_op()
    {
        return $this->aanvulling_op;
    }
    /**
     * Set aanvulling_op value
     * @param \ArrayType\KadasterV2StukdeelArray $aanvulling_op
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setAanvulling_op(\ArrayType\KadasterV2StukdeelArray $aanvulling_op = null)
    {
        $this->aanvulling_op = $aanvulling_op;
        return $this;
    }
    /**
     * Get vermeld_in value
     * @return \ArrayType\KadasterV2OnroerendeZaakReferenceArray|null
     */
    public function getVermeld_in()
    {
        return $this->vermeld_in;
    }
    /**
     * Set vermeld_in value
     * @param \ArrayType\KadasterV2OnroerendeZaakReferenceArray $vermeld_in
     * @return \StructType\KadasterV2Stukdeel
     */
    public function setVermeld_in(\ArrayType\KadasterV2OnroerendeZaakReferenceArray $vermeld_in = null)
    {
        $this->vermeld_in = $vermeld_in;
        return $this;
    }
}
