<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sepaConvertBankAccountNumberRequestType StructType
 * @subpackage Structs
 */
class SepaConvertBankAccountNumberRequestType extends AbstractStructBase
{
    /**
     * The account_number
     * @var string
     */
    public $account_number;
    /**
     * The nbi
     * @var string
     */
    public $nbi;
    /**
     * The country_code
     * @var string
     */
    public $country_code;
    /**
     * Constructor method for sepaConvertBankAccountNumberRequestType
     * @uses SepaConvertBankAccountNumberRequestType::setAccount_number()
     * @uses SepaConvertBankAccountNumberRequestType::setNbi()
     * @uses SepaConvertBankAccountNumberRequestType::setCountry_code()
     * @param string $account_number
     * @param string $nbi
     * @param string $country_code
     */
    public function __construct($account_number = null, $nbi = null, $country_code = null)
    {
        $this
            ->setAccount_number($account_number)
            ->setNbi($nbi)
            ->setCountry_code($country_code);
    }
    /**
     * Get account_number value
     * @return string|null
     */
    public function getAccount_number()
    {
        return $this->account_number;
    }
    /**
     * Set account_number value
     * @param string $account_number
     * @return \StructType\SepaConvertBankAccountNumberRequestType
     */
    public function setAccount_number($account_number = null)
    {
        // validation for constraint: string
        if (!is_null($account_number) && !is_string($account_number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($account_number, true), gettype($account_number)), __LINE__);
        }
        $this->account_number = $account_number;
        return $this;
    }
    /**
     * Get nbi value
     * @return string|null
     */
    public function getNbi()
    {
        return $this->nbi;
    }
    /**
     * Set nbi value
     * @param string $nbi
     * @return \StructType\SepaConvertBankAccountNumberRequestType
     */
    public function setNbi($nbi = null)
    {
        // validation for constraint: string
        if (!is_null($nbi) && !is_string($nbi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nbi, true), gettype($nbi)), __LINE__);
        }
        $this->nbi = $nbi;
        return $this;
    }
    /**
     * Get country_code value
     * @return string|null
     */
    public function getCountry_code()
    {
        return $this->country_code;
    }
    /**
     * Set country_code value
     * @param string $country_code
     * @return \StructType\SepaConvertBankAccountNumberRequestType
     */
    public function setCountry_code($country_code = null)
    {
        // validation for constraint: string
        if (!is_null($country_code) && !is_string($country_code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($country_code, true), gettype($country_code)), __LINE__);
        }
        $this->country_code = $country_code;
        return $this;
    }
}
